module async_mem (/*AUTOARG*/
  // Outputs
  rd_data, 
  // Inputs
  wr_clk, wr_data, wr_cs, addr, rd_cs
  );

  parameter asz = 15,
	    depth = 32768;
  
  input       wr_clk;
  input [7:0] wr_data;
  input       wr_cs;

  input [asz-1:0] addr;
  inout [7:0] 	  rd_data;
  input 	  rd_cs;

  reg [7:0] 	  mem [0:depth-1];

//Nov.9.2004 TAK
      `define Print_Port_Address 12'h3e8  //got z80_test.map file
      `define Print_CAHR_Port_Address 12'h3e9
      `define Print_INT_Port_Address 12'h3eb  // LAST ADDRESS
      `define Print_LONG_Port_Address 12'h3ef  // LAST ADDRESS
 reg [0:639] char_buffer;
	task Cprint;// String OUT until the byte 00 or xx detected with least Byte first and justified.
		integer i;
		begin :Block
			i=0;
			while (1) begin
				if (char_buffer[i*8 +:8] ===8'h00 || char_buffer[i*8 +:8]===8'hxx) begin
						disable Block;
				end	
				$write("%c",char_buffer[i*8 +:8]);
				i=i+1;  
			end
		end
	endtask

  
   integer  counter=0;    
   always @ (posedge wr_clk ) begin
	 if (wr_cs) begin 
             //  mem[$unsigned(a)] <= wr_data;
                     //	if (a >=0 && a<10000 && a !=`Print_Port_Address) $display("%h %h",a,wr_data);
           	   if (addr==`Print_Port_Address) begin
				if (wr_data===8'h00) begin
					
				      char_buffer[counter*8 +:8]=wr_data;
					if (char_buffer[0  +:8*7]==="$finish") begin
							$finish;				
							
					end else if (char_buffer[0  +:8*5]==="$time") begin
							$display("Current Time on Simulation=%d",$time);				
							
					end else  Cprint;//$write("%s",char_buffer);

					for (counter=0; counter< 80; counter=counter+1) begin
						char_buffer[counter*8 +:8]=8'h00;
					end
					counter=0;
				end else begin
					char_buffer[counter*8 +:8]=wr_data;
					counter=counter+1;
				end
		   end
       	   else if (addr==`Print_CAHR_Port_Address) begin
				$write("%h ",wr_data);
		   end else if (addr==`Print_INT_Port_Address) begin
				 $write("%h ",{wr_data,mem[addr-1]});
		   end else if (addr==`Print_LONG_Port_Address) begin
				 $write("%h ",{wr_data,mem[addr-1],mem[addr-2],mem[addr-3]});
		   end 
	end
   end //always

  always @(posedge wr_clk)
    begin
      if (wr_cs)
	mem[addr] <= #1 wr_data;
    end

  assign rd_data = (rd_cs) ? mem[addr] : {8{1'bz}};
	  
endmodule // async_mem
